Version:	5.0.1

%define projecturl	http://llvm.org/svn/llvm-project
%define	branch		branches/release_50
%define libver		5.0

Summary:	The clang/LLVM compiler
Name:		llvm-clang
Release:	%mkrel 1
Source0:	llvm-%{version}.tar.bz2
Patch0:		cfe-5.0.0-mandriva.patch
Url:		http://llvm.org/releases/download.html
License:	LLVM
Group:		Development/C
Provides:	clang = %{version}-%{release}
Provides:	clang-devel = %{version}-%{release}
Provides:	clang-analyzer = %{version}-%{release}
Provides:	llvm = %{version}-%{release}
Provides:	llvm-devel = %{version}-%{release}
Provides:	llvm-static = %{version}-%{release}
%ifarch x86_64
Provides:	clang(x86-64) = %{version}-%{release}
Provides:	clang-devel(x86-64) = %{version}-%{release}
Provides:	clang-analyzer(x86-64) = %{version}-%{release}
Provides:	devel(libLLVM-%{libver}(64bit))
Provides:	llvm(x86-64) = %{version}-%{release}
Provides:	llvm-devel(x86-64) = %{version}-%{release}
Provides:	llvm-static(x86-64) = %{version}-%{release}
%else
Provides:	devel(libLLVM-%{libver})
%endif
Obsoletes:	llvm
Obsoletes:	llvm-devel
Obsoletes:	llvm-static
Obsoletes:	clang
Obsoletes:	clang-devel
Obsoletes:	clang-analyzer
BuildRoot:	%_tmppath/%name-%version-buildroot
BuildRequires:	python >= 2.7
BuildRequires:	cmake >= 3.4.3

%description
Clang/LLVM is a C and C++ compiler.

%prep
rm -rf %{_builddir}/llvm-%{version} %{_builddir}/llvm

cd %{_builddir}
bytes=`wc --bytes %{SOURCE0} | cut -d ' ' -f 1`
if [ "$bytes" != "0" ] ; then
	if which pbzip2 &>/dev/null ; then
		pbzip2 -cd %{SOURCE0} | tar xf -
	else
		bzip2 -cd %{SOURCE0} | tar xf -
	fi
elif which svn &>/dev/null ; then
	svn co %{projecturl}/llvm/%{branch} llvm
	mv -f llvm llvm-%{version}
	pushd llvm-%{version}
	pushd tools
	svn co %{projecturl}/cfe/%{branch} clang
	popd
	pushd projects
	svn co %{projecturl}/compiler-rt/%{branch} compiler-rt
	svn co %{projecturl}/openmp/%{branch} openmp
	popd
	find . -type d -name ".svn" | xargs rm -rf
	popd
	if which pbzip2 &>/dev/null ; then
		tar cf - llvm-%{version} | pbzip2 >%{SOURCE0}
	else
		tar cf - llvm-%{version} | bzip2 >%{SOURCE0}
	fi
else
	echo "Subversion is needed to fetch llvm/clang sources"
	exit 1
fi

cd llvm-%{version}
%patch0 -p1

%build
cd %{_builddir}/llvm-%{version}
mkdir build
pushd build

if which ninja &>/dev/null ; then
%ifarch x86_64
cmake -G "Ninja" -DLLVM_PARALLEL_COMPILE_JOBS=6 -DLLVM_PARALLEL_LINK_JOBS=4 -DLLVM_LIBDIR_SUFFIX=64 -DCMAKE_BUILD_TYPE="Release" -DLLVM_TARGETS_TO_BUILD="X86;AMDGPU" -DLLVM_INCLUDE_EXAMPLES="OFF" -DLLVM_INCLUDE_TESTS="OFF" -DLLVM_BINUTILS_INCDIR="/usr/include" ..
%else
cmake -G "Ninja" -DLLVM_PARALLEL_COMPILE_JOBS=6 -DLLVM_PARALLEL_LINK_JOBS=4 -DCMAKE_BUILD_TYPE="Release" -DLLVM_TARGETS_TO_BUILD="X86;AMDGPU" -DLLVM_INCLUDE_EXAMPLES="OFF" -DLLVM_INCLUDE_TESTS="OFF" -DLLVM_BINUTILS_INCDIR="/usr/include" ..
%endif
else
%ifarch x86_64
cmake -G "Unix Makefiles" -DLLVM_LIBDIR_SUFFIX=64 -DCMAKE_BUILD_TYPE="Release" -DLLVM_TARGETS_TO_BUILD="X86;AMDGPU" -DLLVM_INCLUDE_EXAMPLES="OFF" -DLLVM_INCLUDE_TESTS="OFF" -DLLVM_BINUTILS_INCDIR="/usr/include" ..
%else
cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" -DLLVM_TARGETS_TO_BUILD="X86;AMDGPU" -DLLVM_INCLUDE_EXAMPLES="OFF" -DLLVM_INCLUDE_TESTS="OFF" -DLLVM_BINUTILS_INCDIR="/usr/include" ..
%endif
fi
cmake --build .

%install
cd %{_builddir}/llvm-%{version}/build
rm -rf %{buildroot}
mkdir -p  %{buildroot}%_prefix
cmake -DCMAKE_INSTALL_PREFIX="%{buildroot}%_prefix" -P cmake_install.cmake

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%_bindir/*
%_libdir/*
%_includedir/*
%_datadir/*
%_prefix/libexec/*

%changelog
* Mon Jan 15 2018 adrianomorselli <adrianomorselli> 5.0-1uplos2018
- update
